/*  jis2gb (JIS Kanji to GuoBiao Hanzi converter) Version 1.5
		by Koichi Yasuoka, October 5, 1995 */

#include <stdio.h>
#ifndef UNDEFCHAR
#define UNDEFCHAR 0x2020
#endif
extern unsigned short *JX0208GB2312[],*JX0208GB8565[];
extern unsigned short *JX0212GB2312[],*JX0212GB8565[];
extern unsigned short *MSSJISGB2312[],*MSSJISJX0208[],*MSSJISJX0212[];
FILE *fp;
int GB,SJIS,KANJI,HANZI,ISATTY;

main(argc,argv)
int argc;
char *argv[];
{
  int i;
  GB=SJIS=KANJI=HANZI=0;
  ISATTY=isatty(1);
  while(argc>1){
    if(argv[1][0]!='-')
      break;
    for(i=1;argv[1][i]>0;i++){
      switch(argv[1][i]){
	case 's':
	  SJIS=1;
	  break;
	case 'g':
	  GB|=1;
	  break;
	case 'b':
	  if(GB==5){
	    fprintf(stderr,"jis2gb: option -h contradicts -b\n");
	    exit(2);
	  }
	  GB|=2;
	  break;
	case 'h':
	  if(GB&2){
	    fprintf(stderr,"jis2gb: option -b contradicts -h\n");
	    exit(2);
	  }
	  GB=5;
	  break;
	case 'i':
	  ISATTY=1;
	  break;
	default:
	  fprintf(stderr,"Usage: jis2gb [-sgbhi] [file...]\n");
	  exit(2);
      }
    }
    argc--;
    argv++;
  }
  if(argc==1){
    fp=stdin;
    jis2gb();
    exit(0);
  }
  while(argc>1){
    if((fp=fopen(argv[1],"r"))==NULL)
      fprintf(stderr,"Cannot open %s\n",argv[1]);
    else{
      jis2gb();
      fclose(fp);
    }
    argc--;
    argv++;
  }
  exit(0);
}

jis2gb(){
  int h,l;
  while((l=kanji())>=0){
jis2gb2:
    if(l<256)
      hanzi0(l);
    else if(l<65536){
      h=(l>>8)-161;
      l=(l&255)-161;
      if((GB&1)==0&&JX0208GB8565[h][l]>0)
	hanzi1(JX0208GB8565[h][l]);
      else if(JX0208GB2312[h][l]>0)
	hanzi1(JX0208GB2312[h][l]);
      else if(SJIS==1){
	if(MSSJISJX0208[h][l]>0){
	  l=MSSJISJX0208[h][l];
	  goto jis2gb2;
	}
	else if(MSSJISJX0212[h][l]>0){
	  l=MSSJISJX0212[h][l]+65536;
	  goto jis2gb2;
	}
	else if(MSSJISGB2312[h][l]>0)
	  hanzi1(MSSJISGB2312[h][l]);
	else
	  hanzi1(UNDEFCHAR);
      }
      else
	hanzi1(UNDEFCHAR);
    }
    else{
      h=(l>>8)-417;
      l=(l&255)-161;
      if((GB&1)==0&&JX0212GB8565[h][l]>0)
	hanzi1(JX0212GB8565[h][l]);
      else if(JX0212GB2312[h][l]>0)
	hanzi1(JX0212GB2312[h][l]);
      else
	hanzi1(UNDEFCHAR);
    }
    if(ISATTY)
      fflush(stdout);
  }
}

int kanatbl[]={
         0xa1a3,0xa1d6,0xa1d7,0xa1a2,0xa1a6,0xa5f2,0xa5a1,
  0xa5a3,0xa5a5,0xa5a7,0xa5a9,0xa5e3,0xa5e5,0xa5e7,0xa5c3,
  0xa1bc,0xa5a2,0xa5a4,0xa5a6,0xa5a8,0xa5aa,0xa5ab,0xa5ad,
  0xa5af,0xa5b1,0xa5b3,0xa5b5,0xa5b7,0xa5b9,0xa5bb,0xa5bd,
  0xa5bf,0xa5c1,0xa5c4,0xa5c6,0xa5c8,0xa5ca,0xa5cb,0xa5cc,
  0xa5cd,0xa5ce,0xa5cf,0xa5d2,0xa5d5,0xa5d8,0xa5db,0xa5de,
  0xa5df,0xa5e0,0xa5e1,0xa5e2,0xa5e4,0xa5e6,0xa5e8,0xa5e9,
  0xa5ea,0xa5eb,0xa5ec,0xa5ed,0xa5ef,0xa5f3,0xa1ab,0xa1ac
};

int IBMtbl_FA[]={
  0xfcf1,0xfcf2,0xfcf3,0xfcf4,0xfcf5,0xfcf6,0xfcf7,0xfcf8,
  0xfcf9,0xfcfa,0xadb5,0xadb6,0xadb7,0xadb8,0xadb9,0xadba,
  0xadbb,0xadbc,0xadbd,0xadbe,0xfcfb,0xfcfc,0xfcfd,0xfcfe,
  0xadea,0xad62,0xad64,0xa2e8,0xf9a1,0xf9a2,0xf9a3,0xf9a4,
  0xf9a5,0xf9a6,0xf9a7,0xf9a8,0xf9a9,0xf9aa,0xf9ab,0xf9ac,
  0xf9ad,0xf9ae,0xf9af,0xf9b0,0xf9b1,0xf9b2,0xf9b3,0xf9b4,
  0xf9b5,0xf9b6,0xf9b7,0xf9b8,0xf9b9,0xf9ba,0xf9bb,0xf9bc,
  0xf9bd,0xf9be,0xf9bf,0xf9c0,0xf9c1,0xf9c2,0xf9c3,
  0xf9c4,0xf9c5,0xf9c6,0xf9c7,0xf9c8,0xf9c9,0xf9ca,0xf9cb,
  0xf9cc,0xf9cd,0xf9ce,0xf9cf,0xf9d0,0xf9d1,0xf9d2,0xf9d3,
  0xf9d4,0xf9d5,0xf9d6,0xf9d7,0xf9d8,0xf9d9,0xf9da,0xf9db,
  0xf9dc,0xf9dd,0xf9de,0xf9df,0xf9e0,0xf9e1,0xf9e2,0xf9e3,
  0xf9e4,0xf9e5,0xf9e6,0xf9e7,0xf9e8,0xf9e9,0xf9ea,0xf9eb,
  0xf9ec,0xf9ed,0xf9ee,0xf9ef,0xf9f0,0xf9f1,0xf9f2,0xf9f3,
  0xf9f4,0xf9f5,0xf9f6,0xf9f7,0xf9f8,0xf9f9,0xf9fa,0xf9fb,
  0xf9fc,0xf9fd,0xf9fe,0xfaa1,0xfaa2,0xfaa3,0xfaa4,0xfaa5,
  0xfaa6,0xfaa7,0xfaa8,0xfaa9,0xfaaa,0xfaab,0xfaac,0xfaad,
  0xfaae,0xfaaf,0xfab0,0xfab1,0xfab2,0xfab3,0xfab4,0xfab5,
  0xfab6,0xfab7,0xfab8,0xfab9,0xfaba,0xfabb,0xfabc,0xfabd,
  0xfabe,0xfabf,0xfac0,0xfac1,0xfac2,0xfac3,0xfac4,0xfac5,
  0xfac6,0xfac7,0xfac8,0xfac9,0xfaca,0xfacb,0xfacc,0xfacd,
  0xface,0xfacf,0xfad0,0xfad1,0xfad2,0xfad3,0xfad4,0xfad5,
  0xfad6,0xfad7,0xfad8,0xfad9,0xfada,0xfadb,0xfadc,0xfadd,
  0xfade,0xfadf,0xfae0,0xfae1,0xfae2
};
int IBMtbl_FB[]={
  0xfae3,0xfae4,0xfae5,0xfae6,0xfae7,0xfae8,0xfae9,0xfaea,
  0xfaeb,0xfaec,0xfaed,0xfaee,0xfaef,0xfaf0,0xfaf1,0xfaf2,
  0xfaf3,0xfaf4,0xfaf5,0xfaf6,0xfaf7,0xfaf8,0xfaf9,0xfafa,
  0xfafb,0xfafc,0xfafd,0xfafe,0xfba1,0xfba2,0xfba3,0xfba4,
  0xfba5,0xfba6,0xfba7,0xfba8,0xfba9,0xfbaa,0xfbab,0xfbac,
  0xfbad,0xfbae,0xfbaf,0xfbb0,0xfbb1,0xfbb2,0xfbb3,0xfbb4,
  0xfbb5,0xfbb6,0xfbb7,0xfbb8,0xfbb9,0xfbba,0xfbbb,0xfbbc,
  0xfbbd,0xfbbe,0xfbbf,0xfbc0,0xfbc1,0xfbc2,0xfbc3,
  0xfbc4,0xfbc5,0xfbc6,0xfbc7,0xfbc8,0xfbc9,0xfbca,0xfbcb,
  0xfbcc,0xfbcd,0xfbce,0xfbcf,0xfbd0,0xfbd1,0xfbd2,0xfbd3,
  0xfbd4,0xfbd5,0xfbd6,0xfbd7,0xfbd8,0xfbd9,0xfbda,0xfbdb,
  0xfbdc,0xfbdd,0xfbde,0xfbdf,0xfbe0,0xfbe1,0xfbe2,0xfbe3,
  0xfbe4,0xfbe5,0xfbe6,0xfbe7,0xfbe8,0xfbe9,0xfbea,0xfbeb,
  0xfbec,0xfbed,0xfbee,0xfbef,0xfbf0,0xfbf1,0xfbf2,0xfbf3,
  0xfbf4,0xfbf5,0xfbf6,0xfbf7,0xfbf8,0xfbf9,0xfbfa,0xfbfb,
  0xfbfc,0xfbfd,0xfbfe,0xfca1,0xfca2,0xfca3,0xfca4,0xfca5,
  0xfca6,0xfca7,0xfca8,0xfca9,0xfcaa,0xfcab,0xfcac,0xfcad,
  0xfcae,0xfcaf,0xfcb0,0xfcb1,0xfcb2,0xfcb3,0xfcb4,0xfcb5,
  0xfcb6,0xfcb7,0xfcb8,0xfcb9,0xfcba,0xfcbb,0xfcbc,0xfcbd,
  0xfcbe,0xfcbf,0xfcc0,0xfcc1,0xfcc2,0xfcc3,0xfcc4,0xfcc5,
  0xfcc6,0xfcc7,0xfcc8,0xfcc9,0xfcca,0xfccb,0xfccc,0xfccd,
  0xfcce,0xfccf,0xfcd0,0xfcd1,0xfcd2,0xfcd3,0xfcd4,0xfcd5,
  0xfcd6,0xfcd7,0xfcd8,0xfcd9,0xfcda,0xfcdb,0xfcdc,0xfcdd,
  0xfcde,0xfcdf,0xfce0,0xfce1,0xfce2
};
int IBMtbl_FC[]={
  0xfce3,0xfce4,0xfce5,0xfce6,0xfce7,0xfce8,0xfce9,0xfcea,
  0xfceb,0xfcec,0xfced,0xfcee
};

kanji(){
  int i,j;
  while((i=fgetc(fp))>=0){
    if(i==27){
      if((i=fgetc(fp))=='$'){
	if((i=fgetc(fp))=='B'){
	  KANJI=2;
	  continue;
	}
	else if(i=='@'){
	  KANJI=2;
	  continue;
	}
	else if(i=='('){
	  if((j=fgetc(fp))=='D'){
	    KANJI=4;
	    continue;
	  }
	  else if(j=='B'||j=='@'){
	    KANJI=2;
	    continue;
	  }
	  ungetc(j,fp);
	}
	KANJI=0;
	ungetc(i,fp);
	ungetc('$',fp);
      }
      else if(i=='('){
	if((i=fgetc(fp))=='I'){
	  KANJI=6;
	  continue;
	}
	else if(KANJI>1&&(i=='B'||i=='J')){
	  KANJI=0;
	  continue;
	}
	KANJI=0;
	ungetc(i,fp);
	ungetc('(',fp);
      }
      else if(i=='&'){
	if((j=fgetc(fp))=='@')
	  continue;
	ungetc(j,fp);
	ungetc('&',fp);
      }
      else
	ungetc(i,fp);
      KANJI|=1;
      return(27);
    }
    else if(SJIS==0&&i==142){
      j=fgetc(fp);
      if((j>32&&j<96)||(j>160&&j<224))
	return(kanatbl[(j&127)-33]);
      ungetc(j,fp);
    }
    else if(SJIS==0&&i==143){
      i=fgetc(fp);
      if((i>32&&i<127)||(i>160&&i<255)){
	j=fgetc(fp);
	if((j>32&&j<127)||(j>160&&j<255))
	  return(((i<<8)+j)|0x18080);
	ungetc(j,fp);
      }
      ungetc(i,fp);
      i=143;
    }
    else if(SJIS==0&&i>160&&i<255){
      j=fgetc(fp);
      if(j>160&&j<255)
	return((i<<8)+j);
      ungetc(j,fp);
    }
    else if(SJIS==1&&i>128&&i<240&&i!=160){
      if(i>160&&i<224)
	return(kanatbl[i-161]);
      if(i>223)
	i-=64;
      j=fgetc(fp);
      if(j>63&&j<127)
	return((i<<9)+j-24735);
      else if(j>127&&j<159)
	return((i<<9)+j-24736);
      else if(j>158&&j<253)
	return((i<<9)+j-24574);
      ungetc(j,fp);
      if(i>159)
	i+=64;
    }
    else if(SJIS==1&&i==250){
      j=fgetc(fp);
      if(j>63&&j<127)
	return(IBMtbl_FA[j-64]);
      else if(j>127&&j<253)
	return(IBMtbl_FA[j-65]);
      ungetc(j,fp);
    }
    else if(SJIS==1&&i==251){
      j=fgetc(fp);
      if(j>63&&j<127)
	return(IBMtbl_FB[j-64]);
      else if(j>127&&j<253)
	return(IBMtbl_FB[j-65]);
      ungetc(j,fp);
    }
    else if(SJIS==1&&i==252){
      j=fgetc(fp);
      if(j>63&&j<76)
	return(IBMtbl_FC[j-64]);
      ungetc(j,fp);
    }
    else if(KANJI==2&&i>32&&i<127){
      j=fgetc(fp);
      if(j>32&&j<127)
	return((i<<8)+j+0x8080);
      ungetc(j,fp);
    }
    else if(KANJI==4&&i>32&&i<127){
      j=fgetc(fp);
      if(j>32&&j<127)
	return((i<<8)+j+0x18080);
      ungetc(j,fp);
    }
    else if(KANJI==6&&i>32&&i<96)
      return(kanatbl[i-33]);
    else if((KANJI&1)&&(i<32||(i>='@'&&i<='Z')||(i>='a'&&i<='z')))
      KANJI&=6;
    return(i);
  }
  return(-1);
}

hanzi0(c)
int c;
{
  if(HANZI){
    if(GB==5)
      printf("~}");
    else if((GB&2)==0)
      printf("\033(B");
    HANZI=0;
  }
  putchar(c);
}

hanzi1(c)
int c;
{
  if(HANZI==0){
    switch(GB){
      case 0:
	printf("\033$(E");
	break;
      case 1:
	printf("\033$A");
	break;
      case 5:
	printf("~{");
    }
    HANZI=1;
  }
  if(GB&2)
    printf("%c%c",c>>8,c&255);
  else
    printf("%c%c",(c>>8)&127,c&127);
}

unsigned short nulltbl[]={
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};
